package betterwithmods.module.tweaks;

import betterwithmods.common.BWOreDictionary;
import betterwithmods.common.BWRegistry;
import betterwithmods.module.Feature;
import betterwithmods.util.InvUtils;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;

import java.util.Arrays;

/**
 * Created by primetoxinz on 4/20/17.
 */
public class KilnSmelting extends Feature {
    private static int oreProductionCount;

    @Override
    public void setupConfig() {
        oreProductionCount = loadPropInt("Ore Production Count", "Number of Materials returned from Smelting an Ore in the Kiln", 1);
    }

    @Override
    public void postInit(FMLPostInitializationEvent event) {
        BWOreDictionary.oreNames.stream().flatMap(ore -> Arrays.stream(ore.func_193365_a())).filter(s -> s.func_77973_b() instanceof ItemBlock).forEach(input -> {
            ItemStack output = FurnaceRecipes.func_77602_a().func_151395_a(input).func_77946_l();
            BWRegistry.KILN.addStokedRecipe(input, InvUtils.setCount(output, oreProductionCount));
        });

    }

    @Override
    public String getFeatureDescription() {
        return "Allows Kiln to Smelt Ores";
    }
}
